#3 could not determine MaxClients

closed-fixed
nobody
1
2009-08-13
2009-08-08
punjab
No

I have last mod_qos 8.13 enabled.
If i add this line in all virtual hosts:
QS_LocRequestLimit / 10
then apache not run. In error log i have this lines repeated with every start attempt

[Sat Aug 08 22:36:32 2009] [emerg] mod_qos(007): could not determine MaxClients
[Sat Aug 08 22:36:32 2009] [emerg] mod_qos(004): could not create a-mutex: No space left on device

Disk space is not a problem.
I think.. problem can be in too many virtualhosts? Number is 634. If I add line in just one, then all is ok.
Maybe too many semaphores? I don't know.

Discussion

  • You are right. The current version of mod_qos uses separate mutexes for each virtual host. Guess it make sense to change this behavior with the next release in order to reduce resource consumption.

     
    • status: open --> open-later
     
    • priority: 5 --> 1
     
  • a code change is available via CVS

    http://mod-qos.cvs.sourceforge.net/viewvc/\*checkout*/mod-qos/src/httpd_src/modules/qos/mod_qos.c?revision=5.163

    the change will be included in version 8.16 of mod_qos

     
  • punjab
    punjab
    2009-08-11

    Sorry. No luck with new linked code. Same result:

    [Tue Aug 11 14:27:58 2009] [emerg] mod_qos(007): could not determine MaxClients
    [Tue Aug 11 14:27:58 2009] [emerg] mod_qos(004): could not create a-mutex: No space left on device
    [Tue Aug 11 14:28:01 2009] [emerg] mod_qos(007): could not determine MaxClients
    [Tue Aug 11 14:28:01 2009] [emerg] mod_qos(004): could not create a-mutex: No space left on device
    [Tue Aug 11 14:28:24 2009] [emerg] mod_qos(007): could not determine MaxClients
    [Tue Aug 11 14:28:25 2009] [emerg] mod_qos(007): could not determine MaxClients

    Apache don't start until i remove all apache owner semaphores and deactivate mod_qos directive from virtualhosts.

    I cannot experiment too much. It's little production server.
    If you need some other information, tell me. I can send some outputs.

     
  • Ups... I forgot to check in the new code. Sorry for the inconvenience.

    About the "MaxClient" settings. Do you have specified this directive in your configuration?

     
  • I've released version 8.16 which should solve the mutex problem having so many virtual hosts.

     
    • status: open-later --> open-fixed
     
  • punjab
    punjab
    2009-08-13

    Version 8.16 fix this problem

     
  • punjab
    punjab
    2009-08-13

    • status: open-fixed --> closed-fixed